#!/usr/bin/perl -w

#
# Delete all entries which fall inside the restriction.
# These happen when you add new restrictions.
#

use strict;
use DBI;
use FindBin qw($Bin);

my $DBDIR="";
{
    my @a=split("/",$Bin);
    pop(@a);
    $DBDIR=join("/",@a)."/db";
}

my $dbh=DBI->connect("dbi:SQLite:dbname=$DBDIR/newports.db","","");

my %restrictions=();

{
    my $sth=$dbh->prepare("
	SELECT	directory,restriction
	FROM	restrictports
    ");
    $sth->execute();
    while (my @a=$sth->fetchrow_array()) {
	$restrictions{$a[0]}{$a[1]}=1;
    }
}

my %tobedeleted=();
{
    my $sth_select=$dbh->prepare("
	SELECT  oid,newversion
	FROM	newports
	WHERE	directory=?
    ");
    foreach my $dir (sort(keys(%restrictions))) {
	$sth_select->execute($dir);
	while (my @a=$sth_select->fetchrow_array()) {
	    
	    foreach my $r (keys(%{$restrictions{$dir}})) {
		if ($r eq "minor-even") {
		    if ($a[1]=~/^\d+\.(\d+)/) {
			if ($1%2!=0) {
			    $tobedeleted{$a[0]}{dir}=$dir;
			    $tobedeleted{$a[0]}{newversion}=$a[1];
			    print "Scheduling #$a[0] - $dir - version $a[1] (minor-even)\n";
			}
		    }
		    next;
		}
		if ($r eq "minor-odd") {
		    if ($a[1]=~/^\d+\.(\d+)/) {
			if ($1%2!=1) {
			    $tobedeleted{$a[0]}{dir}=$dir;
			    $tobedeleted{$a[0]}{newversion}=$a[1];
			    print "Scheduling #$a[0] - $dir - version $a[1] (minor-odd)\n";
			}
		    }
		    next;
		}
		{
		    next if (substr($a[1],0,length($r)) eq $r);
		    $tobedeleted{$a[0]}{dir}=$dir;
		    $tobedeleted{$a[0]}{newversion}=$a[1];
		    print "Scheduling #$a[0] - $dir - version $a[1] (simple string comparison)\n";
		}
	    }
	}
    }
}

{
    my $sth_delete=$dbh->prepare("
	DELETE FROM newports
	WHERE	oid=?
    ");
    foreach my $oid (sort(keys(%tobedeleted))) {
	$sth_delete->execute($oid);
	print "Removing #$oid - ",$tobedeleted{$oid}{dir}," - version ",$tobedeleted{$oid}{newversion},"\n";
    }
}

$dbh->disconnect;
