#!/usr/bin/perl -w

use strict;
use DBI;
use FindBin qw($Bin);

my $DBDIR="";
{
    my @a=split("/",$Bin);
    pop(@a);
    $DBDIR=join("/",@a)."/db";
}

my $dbh=DBI->connect("dbi:SQLite:dbname=$DBDIR/newports.db","","");

my %ports=();
my %directories=();

my $sth=$dbh->prepare("
    SELECT	directory,category,port,currentversion,newversion,maintainer
    FROM	newports
    WHERE	reported=0
");
$sth->execute();
while (my @a=$sth->fetchrow_array()) {
    $ports{$a[0]}{$a[3]}{$a[4]}=1;
    $directories{$a[0]}{category}=$a[1];
    $directories{$a[0]}{port}=$a[2];
    $directories{$a[0]}{maintainer}=$a[5];
}

foreach my $directory (sort(keys(%ports))) {
    foreach my $curversion (sort(keys(%{$ports{$directory}}))) {
	my $cnewversion=0;
	my $lastversion=0;
	foreach my $newversion (sort(keys(%{$ports{$directory}{$curversion}}))) {
	    $cnewversion++;
	    $lastversion=$newversion;
	}
	my @a1=split(/\./,$curversion);
	my @a2=split(/\./,$lastversion);
	my @a;
	if ($#a1>$#a2) {
	    @a=@a1;
	} else {
	    @a=@a2;
	}
	if ($#a!=0 && $#a+1==$cnewversion) {
	    print "$directory - $curversion - ",$directories{$directory}{maintainer},"\n";
	    foreach my $newversion (sort(keys(%{$ports{$directory}{$curversion}}))) {
		print "  $newversion\n";
	    }
	}
    }
}
