#!/usr/bin/perl -w

#
# Delete duplicates from the database.
# Duplicates are caused when you manually delete entries from the
# checkeddirectories table and re-run the find_new_versions.pl
# script.
#
# Keep running this script until there are no more entries reported
# to be deleted.
#

use strict;
use DBI;
use FindBin qw($Bin);

my $DBDIR="";
{
    my @a=split("/",$Bin);
    pop(@a);
    $DBDIR=join("/",@a)."/db";
}

my $dbh=DBI->connect("dbi:SQLite:dbname=$DBDIR/newports.db","","");

my %unreported=();
my %reported=();

{
    my $sth=$dbh->prepare("
	SELECT	oid,directory,url,reported
	FROM	newports
    ");
    $sth->execute();
    while (my @a=$sth->fetchrow_array()) {
	if ($a[3] eq "0") {
	    $unreported{$a[1]}{$a[2]}=$a[0];
	} else {
	    $reported{$a[1]}{$a[2]}=$a[0];
	}
    }
}

my $sth=$dbh->prepare("DELETE FROM NEWPORTS WHERE OID=?");

foreach my $dir (sort(keys(%unreported))) {
    foreach my $url (sort(keys(%{$unreported{$dir}}))) {
	if (defined $reported{$dir}{$url}) {
	    print "Deleting - ",$unreported{$dir}{$url}," - $dir\n";
	    $sth->execute($unreported{$dir}{$url});
	    $sth->finish();
	}
    }
}

{
    my @a;
    @a=keys(%unreported);print "Unreported: $#a\n";
    @a=keys(%reported);print "Reported: $#a\n";
}
