#!/bin/sh

root=`echo $0 | sed -e 's/\/.*$//'`
if [ -z "$root" ]; then
	nul=$0
else
	nul=`pwd`/$0
fi

DBDIR=`echo $nul | sed -e 's,bin/[a-z_\.]*$,db,'`;
BINDIR=`echo $nul | sed -e 's,/[a-z_\.]*$,,'`;

if [ ! -f ${DBDIR}/newports.db ]; then
	echo "Couldn't find location of newports.db. Please run $0 with the full path."
	exit
fi
if [ ! -f ${BINDIR}/find_new_versions.pl ]; then
	echo "Couldn't find location of find_new_versions.pl. Please run $0 with the full path."
	exit
fi

LOG=${DBDIR}/newports.log
CONCURRENT=${DBDIR}/concurrent

cd /usr/ports

MAINTAINER=$1
INDEXFILE=`make -V INDEXFILE`

if [ -z "${MAINTAINER}" ]; then
	PORTS=`cat ${INDEXFILE} | awk -F\| '{ print $2 }' | sed -e 's,/usr/ports/,,'`
else
	PORTS=`grep -i ${MAINTAINER} ${INDEXFILE} | awk -F\| '{ print $2 }' | sed -e 's,/usr/ports/,,'`
fi

PORTS=`echo ${PORTS} | ${BINDIR}/filter_ports_alreadychecked.pl`

if [ -z "${PORTS}" ]; then
	echo "No ports found."
	exit
fi

> ${LOG}

test -f ${CONCURRENT} || echo 10 > ${CONCURRENT}

for p in ${PORTS}; do
	if [ ! -f ${p}/Makefile ]; then
		echo "Ports Makefile not found: $p"
		continue
	fi
	while [ true ]; do
		j=`ps xauww | grep find_new_versions.pl | grep -v grep | wc -l`
		j=`expr $j + 0`
		if [ $j -lt `cat ${CONCURRENT}` ]; then
			break
		fi
		sleep 1
	done

	cd $p
	echo $p
	${BINDIR}/find_new_versions.pl $c/$p &
	echo `date` - $j - $c/$p >> ${LOG}
	cd ../..
done

while [ true ]; do
	j=`ps xauww | grep find_new_versions.pl | grep -v grep | wc -l`
	j=`expr $j + 0`
	if [ "$j" = "0" ]; then
		echo "`date` - Finished!" >> ${LOG}
		break
	fi
	echo "`date` - Still running: $j processes" >> ${LOG}
	sleep 10
done
